'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RewardCardActionOnMOrMore = exports.RewardCardAction = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _marger = require('kitten/components/layout/marger');

var _manageContribution = require('kitten/components/cards/reward-card/manage-contribution');

var _button = require('kitten/components/cards/reward-card/button');

var _deprecated = require('kitten/helpers/utils/deprecated');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RewardCardAction = exports.RewardCardAction = function RewardCardAction(_ref) {
  var manageContributionDescription = _ref.manageContributionDescription,
      manageContributionLinkLabel = _ref.manageContributionLinkLabel,
      manageContributionLinkHref = _ref.manageContributionLinkHref,
      buttonLabel = _ref.buttonLabel,
      buttonOnMouseEnter = _ref.buttonOnMouseEnter,
      buttonOnMouseLeave = _ref.buttonOnMouseLeave,
      buttonOnClick = _ref.buttonOnClick,
      isDisabled = _ref.isDisabled,
      isTinyVersion = _ref.isTinyVersion,
      isSOrLessVersion = _ref.isSOrLessVersion,
      topMargin = _ref.topMargin;

  var hasActionContent = buttonLabel || manageContributionDescription;

  if (!hasActionContent) return null;

  return _react2.default.createElement(
    _deprecated.Deprecated,
    { warningMessage: 'Please use RewardCard sub-component to make your composition. You can check some examples on https://kisskissbankbank.github.io/kitten/' },
    _react2.default.createElement(
      _react.Fragment,
      null,
      manageContributionDescription && _react2.default.createElement(
        _marger.Marger,
        {
          top: topMargin,
          bottom: !manageContributionDescription ? 0 : 2
        },
        _react2.default.createElement(_manageContribution.ManageContribution, {
          description: manageContributionDescription,
          linkLabel: manageContributionLinkLabel,
          linkHref: manageContributionLinkHref,
          isDisabled: isDisabled,
          isTinyVersion: isTinyVersion,
          isSOrLessVersion: isSOrLessVersion
        })
      ),
      _react2.default.createElement(_button.RewardCardButton, {
        label: buttonLabel,
        onMouseEnter: buttonOnMouseEnter,
        onMouseLeave: buttonOnMouseLeave,
        onClick: buttonOnClick,
        isDisabled: isDisabled,
        isTinyVersion: isTinyVersion
      })
    )
  );
};

var RewardCardActionOnMOrMore = exports.RewardCardActionOnMOrMore = function RewardCardActionOnMOrMore(_ref2) {
  var manageContributionDescription = _ref2.manageContributionDescription,
      manageContributionLinkLabel = _ref2.manageContributionLinkLabel,
      manageContributionLinkHref = _ref2.manageContributionLinkHref,
      buttonLabel = _ref2.buttonLabel,
      buttonOnMouseEnter = _ref2.buttonOnMouseEnter,
      buttonOnMouseLeave = _ref2.buttonOnMouseLeave,
      buttonOnClick = _ref2.buttonOnClick,
      isDisabled = _ref2.isDisabled,
      isTinyVersion = _ref2.isTinyVersion,
      isSOrLessVersion = _ref2.isSOrLessVersion;

  var hasActionContent = buttonLabel || manageContributionDescription;

  if (!hasActionContent) return null;

  return _react2.default.createElement(
    _deprecated.Deprecated,
    { warningMessage: 'Please use RewardCard sub-component to make your composition. You can check some examples on https://kisskissbankbank.github.io/kitten/' },
    _react2.default.createElement(
      _marger.Marger,
      { top: '3' },
      _react2.default.createElement(_button.RewardCardButton, {
        label: buttonLabel,
        onMouseEnter: buttonOnMouseEnter,
        onMouseLeave: buttonOnMouseLeave,
        onClick: buttonOnClick,
        isDisabled: isDisabled,
        isTinyVersion: isTinyVersion
      }),
      manageContributionDescription && _react2.default.createElement(
        _marger.Marger,
        { top: !manageContributionDescription ? 0 : 2 },
        _react2.default.createElement(_manageContribution.ManageContribution, {
          description: manageContributionDescription,
          linkLabel: manageContributionLinkLabel,
          linkHref: manageContributionLinkHref,
          isDisabled: isDisabled,
          isTinyVersion: isTinyVersion,
          isSOrLessVersion: isSOrLessVersion
        })
      )
    )
  );
};

var commonPropTypes = {
  manageContributionDescription: _propTypes2.default.string,
  manageContributionLinkLabel: _propTypes2.default.string,
  manageContributionLinkHref: _propTypes2.default.string,
  buttonLabel: _propTypes2.default.string,
  buttonOnMouseEnter: _propTypes2.default.func,
  buttonOnMouseLeave: _propTypes2.default.func,
  buttonOnClick: _propTypes2.default.func,
  isDisabled: _propTypes2.default.bool,
  isTinyVersion: _propTypes2.default.bool.isRequired,
  isSOrLessVersion: _propTypes2.default.bool.isRequired
};

var commonDefaultProps = {
  manageContributionDescription: '',
  manageContributionLinkLabel: '',
  manageContributionLinkHref: '',
  buttonLabel: '',
  buttonOnMouseEnter: function buttonOnMouseEnter() {},
  buttonOnMouseLeave: function buttonOnMouseLeave() {},
  buttonOnClick: function buttonOnClick() {},
  isDisabled: false,
  topMargin: 0
};

RewardCardAction.propTypes = _extends({}, commonPropTypes, {
  topMargin: _propTypes2.default.number
});

RewardCardAction.defaultProps = _extends({}, commonDefaultProps);
RewardCardActionOnMOrMore.propTypes = _extends({}, commonPropTypes);
RewardCardActionOnMOrMore.defaultProps = _extends({}, commonDefaultProps);