'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RewardCardImage = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _rewardCard = require('kitten/components/cards/reward-card');

var _deprecated = require('kitten/helpers/utils/deprecated');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RewardCardImageBase = function RewardCardImageBase(_ref) {
  var isDisabled = _ref.isDisabled,
      imageProps = _ref.imageProps;

  var imageStyles = [isDisabled && _rewardCard.styles.disabled];
  var shouldDisplayImage = imageProps && imageProps.src;

  if (!shouldDisplayImage) return null;

  return _react2.default.createElement(
    _deprecated.Deprecated,
    { warningMessage: 'Please use RewardCard sub-component to make your composition. You can check some examples on https://kisskissbankbank.github.io/kitten/' },
    _react2.default.createElement(
      'div',
      { style: imageStyles, disabled: isDisabled },
      _react2.default.createElement('img', _extends({}, imageProps, { alt: imageProps.alt || '', style: _rewardCard.styles.image }))
    )
  );
};

RewardCardImageBase.propTypes = {
  isDisabled: _propTypes2.default.bool,
  imageProps: _propTypes2.default.object
};

RewardCardImageBase.defaultProps = {
  isDisabled: false,
  imageProps: {}
};

var RewardCardImage = exports.RewardCardImage = (0, _radium2.default)(RewardCardImageBase);