'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Info = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _text = require('kitten/components/typography/text');

var _rewardCard = require('kitten/components/cards/reward-card');

var _deprecated = require('kitten/helpers/utils/deprecated');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Text = (0, _radium2.default)(_text.Text);

var Info = exports.Info = function Info(_ref) {
  var label = _ref.label,
      value = _ref.value,
      viewportIsTabletOrLess = _ref.viewportIsTabletOrLess,
      isTinyVersion = _ref.isTinyVersion;

  if (!label) return null;

  var infosLists = isTinyVersion ? _rewardCard.styles.infos.lists.tinyVersion : _rewardCard.styles.infos.lists;

  var InfoBase = _react2.default.createElement(
    _deprecated.Deprecated,
    { warningMessage: 'Please use RewardCard sub-component to make your composition. You can check some examples on https://kisskissbankbank.github.io/kitten/' },
    _react2.default.createElement(
      Text,
      { color: 'font1', weight: 'regular', style: infosLists },
      label + ' ',
      _react2.default.createElement(
        Text,
        { weight: 'light' },
        value
      )
    )
  );

  return _react2.default.createElement(
    _react.Fragment,
    null,
    (viewportIsTabletOrLess || isTinyVersion) && _react2.default.createElement(
      'div',
      null,
      InfoBase
    ),
    !viewportIsTabletOrLess && !isTinyVersion && InfoBase
  );
};

Info.propTypes = {
  label: _propTypes2.default.string,
  value: _propTypes2.default.string,
  viewportIsTabletOrLess: _propTypes2.default.bool.isRequired,
  isTinyVersion: _propTypes2.default.bool.isRequired
};

Info.defaultProps = {
  label: null,
  value: null
};