'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RewardCardInfos = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _rewardCard = require('kitten/components/cards/reward-card');

var _info = require('kitten/components/cards/reward-card/info');

var _marger = require('kitten/components/layout/marger');

var _deprecated = require('kitten/helpers/utils/deprecated');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RewardCardInfosBase = function RewardCardInfosBase(_ref) {
  var infos = _ref.infos,
      isDisabled = _ref.isDisabled,
      viewportIsTabletOrLess = _ref.viewportIsTabletOrLess,
      isTinyVersion = _ref.isTinyVersion;

  var styleInfos = [isDisabled && _rewardCard.styles.disabled];

  if (infos.length === 0) return null;

  return _react2.default.createElement(
    _deprecated.Deprecated,
    { warningMessage: 'Please use RewardCard sub-component to make your composition. You can check some examples on https://kisskissbankbank.github.io/kitten/' },
    _react2.default.createElement(
      'div',
      { style: styleInfos, disabled: isDisabled },
      _react2.default.createElement(
        _marger.Marger,
        { top: '2', bottom: '3' },
        infos && infos.map(function (info) {
          return _react2.default.createElement(_info.Info, {
            key: info.label,
            label: info.label,
            value: info.value,
            viewportIsTabletOrLess: viewportIsTabletOrLess,
            isTinyVersion: isTinyVersion
          });
        })
      )
    )
  );
};

RewardCardInfosBase.propTypes = {
  infos: _propTypes2.default.array,
  isDisabled: _propTypes2.default.bool,
  viewportIsTabletOrLess: _propTypes2.default.bool.isRequired,
  isTinyVersion: _propTypes2.default.bool.isRequired
};

RewardCardInfosBase.defaultProps = {
  infos: [],
  isDisabled: false
};

var RewardCardInfos = exports.RewardCardInfos = (0, _radium2.default)(RewardCardInfosBase);