'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ManageContribution = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _grid = require('kitten/components/grid/grid');

var _text = require('kitten/components/typography/text');

var _checkedIcon = require('kitten/components/cards/reward-card/checked-icon');

var _rewardCard = require('kitten/components/cards/reward-card');

var _deprecated = require('kitten/helpers/utils/deprecated');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Grid = (0, _radium2.default)(_grid.Grid);

var ManageContributionBase = function ManageContributionBase(_ref) {
  var description = _ref.description,
      linkLabel = _ref.linkLabel,
      linkHref = _ref.linkHref,
      isDisabled = _ref.isDisabled,
      isTinyVersion = _ref.isTinyVersion,
      isSOrLessVersion = _ref.isSOrLessVersion;

  if (!description) return null;
  if (isTinyVersion && isDisabled) return null;

  var choiceButtonPaddings = isTinyVersion ? _rewardCard.styles.choiceButton.paddings.tinyVersion : _rewardCard.styles.choiceButton.paddings;

  return _react2.default.createElement(
    _deprecated.Deprecated,
    { warningMessage: 'Please use RewardCard sub-component to make your composition. You can check some examples on https://kisskissbankbank.github.io/kitten/' },
    _react2.default.createElement(
      _react.Fragment,
      null,
      isSOrLessVersion && _react2.default.createElement(
        Grid,
        { style: choiceButtonPaddings },
        _react2.default.createElement(
          _grid.GridCol,
          null,
          _react2.default.createElement(
            'div',
            { style: _rewardCard.styles.myContribution },
            _react2.default.createElement(_checkedIcon.RewardCardCheckedIcon, null),
            _react2.default.createElement(
              'div',
              { style: _rewardCard.styles.myContribution.text },
              _react2.default.createElement(
                _text.Text,
                { color: 'font1', size: 'tiny', weight: 'regular' },
                description,
                _react2.default.createElement('br', null),
                _react2.default.createElement(
                  _text.Text,
                  {
                    tag: 'a',
                    href: linkHref,
                    color: 'primary1',
                    weight: 'regular',
                    decoration: 'none'
                  },
                  linkLabel
                )
              )
            )
          )
        )
      ),
      !isSOrLessVersion && _react2.default.createElement(
        'div',
        { style: _rewardCard.styles.myContribution },
        _react2.default.createElement(_checkedIcon.RewardCardCheckedIcon, null),
        _react2.default.createElement(
          'div',
          { style: _rewardCard.styles.myContribution.text },
          _react2.default.createElement(
            _text.Text,
            { color: 'font1', size: 'tiny', weight: 'regular' },
            description,
            _react2.default.createElement('br', null),
            _react2.default.createElement(
              _text.Text,
              {
                tag: 'a',
                href: linkHref,
                color: 'primary1',
                weight: 'regular',
                decoration: 'none'
              },
              linkLabel
            )
          )
        )
      )
    )
  );
};

ManageContributionBase.propTypes = {
  description: _propTypes2.default.string,
  linkLabel: _propTypes2.default.string,
  linkHref: _propTypes2.default.string,
  isDisabled: _propTypes2.default.bool,
  isTinyVersion: _propTypes2.default.bool.isRequired,
  isSOrLessVersion: _propTypes2.default.bool.isRequired
};

ManageContributionBase.defaultProps = {
  description: '',
  linkLabel: '',
  linkHref: '',
  isDisabled: false
};

var ManageContribution = exports.ManageContribution = (0, _radium2.default)(ManageContributionBase);