'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RewardCardStarredBadge = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _iconBadge = require('kitten/components/notifications/icon-badge');

var _starIcon = require('kitten/components/icons/star-icon');

var _typography = require('kitten/helpers/utils/typography');

var _colorsConfig = require('kitten/constants/colors-config');

var _colorsConfig2 = _interopRequireDefault(_colorsConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var IconBadge = (0, _radium2.default)(_iconBadge.IconBadge);

var RewardCardStarredBadgeBase = function (_Component) {
  _inherits(RewardCardStarredBadgeBase, _Component);

  function RewardCardStarredBadgeBase() {
    _classCallCheck(this, RewardCardStarredBadgeBase);

    return _possibleConstructorReturn(this, (RewardCardStarredBadgeBase.__proto__ || Object.getPrototypeOf(RewardCardStarredBadgeBase)).apply(this, arguments));
  }

  _createClass(RewardCardStarredBadgeBase, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          disabled = _props.disabled;

      var starredBadgeStyles = [styles.base, disabled && styles.disabled];
      var iconBadgeStyles = [styles.badge.base, disabled && styles.badge.disabled];

      return _react2.default.createElement(
        'div',
        { style: starredBadgeStyles },
        _react2.default.createElement(
          IconBadge,
          { big: true, style: iconBadgeStyles },
          _react2.default.createElement(_starIcon.StarIcon, { className: 'k-IconBadge__svg', style: styles.icon })
        ),
        _react2.default.createElement(
          'div',
          { style: styles.content },
          children
        )
      );
    }
  }]);

  return RewardCardStarredBadgeBase;
}(_react.Component);

RewardCardStarredBadgeBase.propTypes = {
  disabled: _propTypes2.default.bool,
  children: _propTypes2.default.node
};
RewardCardStarredBadgeBase.defaultProps = {
  disabled: false,
  children: null
};


var styles = {
  base: {
    display: 'flex',
    lineHeight: '1rem',
    alignItems: 'center',
    marginBottom: (0, _typography.pxToRem)(20)
  },
  content: {
    display: 'flex',
    flexDirection: 'column'
  },
  badge: {
    base: {
      marginRight: (0, _typography.pxToRem)(10)
    },
    disabled: {
      backgroundColor: _colorsConfig2.default.line2
    }
  },
  icon: {
    height: (0, _typography.pxToRem)(14),
    width: (0, _typography.pxToRem)(14)
  },
  disabled: {
    color: _colorsConfig2.default.font2,
    cursor: 'not-allowed'
  }
};

var RewardCardStarredBadge = exports.RewardCardStarredBadge = (0, _radium2.default)(RewardCardStarredBadgeBase);