'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RewardCardTitle = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _text = require('kitten/components/typography/text');

var _horizontalStroke = require('kitten/components/layout/horizontal-stroke');

var _marger = require('kitten/components/layout/marger');

var _typography = require('kitten/helpers/utils/typography');

var _colorsConfig = require('kitten/constants/colors-config');

var _colorsConfig2 = _interopRequireDefault(_colorsConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Text = (0, _radium2.default)(_text.Text);
var HorizontalStroke = (0, _radium2.default)(_horizontalStroke.HorizontalStroke);

var RewardCardTitleBase = function (_Component) {
  _inherits(RewardCardTitleBase, _Component);

  function RewardCardTitleBase() {
    _classCallCheck(this, RewardCardTitleBase);

    return _possibleConstructorReturn(this, (RewardCardTitleBase.__proto__ || Object.getPrototypeOf(RewardCardTitleBase)).apply(this, arguments));
  }

  _createClass(RewardCardTitleBase, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          tagName = _props.tagName,
          disabled = _props.disabled;

      var titleStyles = [styles.base, disabled && styles.disabled];
      var strokeStyles = [styles.stroke.base, disabled && styles.stroke.disabled];

      return _react2.default.createElement(
        _react.Fragment,
        null,
        _react2.default.createElement(
          Text,
          {
            fontStyle: 'italic',
            weight: 'bold',
            tag: tagName,
            color: 'font1',
            style: titleStyles
          },
          children
        ),
        _react2.default.createElement(HorizontalStroke, { size: 'default', style: strokeStyles })
      );
    }
  }]);

  return RewardCardTitleBase;
}(_react.Component);

RewardCardTitleBase.propTypes = {
  children: _propTypes2.default.string,
  tagName: _propTypes2.default.string,
  disabled: _propTypes2.default.bool
};
RewardCardTitleBase.defaultProps = {
  children: '',
  tagName: 'h6',
  disabled: false
};


var styles = {
  base: {
    fontSize: (0, _typography.pxToRem)(24),
    lineHeight: (0, _typography.pxToRem)(34),
    margin: '0 0 ' + (0, _typography.pxToRem)(15) + ' 0'
  },
  stroke: {
    base: {
      marginBottom: (0, _typography.pxToRem)(30)
    },
    disabled: {
      backgroundColor: _colorsConfig2.default.font2
    }
  },
  disabled: {
    color: _colorsConfig2.default.font2,
    cursor: 'not-allowed'
  }
};

var RewardCardTitle = exports.RewardCardTitle = (0, _radium2.default)(RewardCardTitleBase);