'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SimpleCarousel = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _marger = require('kitten/components/layout/marger');

var _colorsConfig = require('kitten/constants/colors-config');

var _colorsConfig2 = _interopRequireDefault(_colorsConfig);

var _range = require('kitten/helpers/utils/range');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Marger = (0, _radium2.default)(_marger.Marger);

var SimpleCarouselBase = function (_Component) {
  _inherits(SimpleCarouselBase, _Component);

  function SimpleCarouselBase(props) {
    _classCallCheck(this, SimpleCarouselBase);

    var _this = _possibleConstructorReturn(this, (SimpleCarouselBase.__proto__ || Object.getPrototypeOf(SimpleCarouselBase)).call(this, props));

    _this.showPagination = function () {
      return _this.state.totalPagesCount > 1;
    };

    _this.handlePageClick = function (numPage) {
      return function () {
        _this.setState({ currentPageNumber: numPage });
      };
    };

    _this.state = {
      currentPageNumber: 0,
      totalPagesCount: _react2.default.Children.toArray(props.children).length
    };
    return _this;
  }

  _createClass(SimpleCarouselBase, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var children = this.props.children;
      var _state = this.state,
          totalPagesCount = _state.totalPagesCount,
          currentPageNumber = _state.currentPageNumber;

      var rangePage = (0, _range.createRangeFromZeroTo)(totalPagesCount);

      return _react2.default.createElement(
        _react.Fragment,
        null,
        _react2.default.createElement(
          Marger,
          { bottom: this.showPagination() ? 4 : 0, style: styles.container },
          _react2.default.Children.map(children, function (item, index) {
            var itemStyle = [styles.item, index !== currentPageNumber && styles.item.hide];

            return _react2.default.createElement(
              'div',
              { key: item.key, style: itemStyle },
              item
            );
          })
        ),
        this.showPagination() && _react2.default.createElement(
          Marger,
          { top: '4', bottom: '4', style: styles.pagination },
          rangePage.map(function (numPage) {
            var pageStyle = [styles.page, numPage === currentPageNumber && styles.page.active];

            return _react2.default.createElement('div', {
              key: numPage,
              style: pageStyle,
              onClick: _this2.handlePageClick(numPage)
            });
          })
        )
      );
    }
  }]);

  return SimpleCarouselBase;
}(_react.Component);

var styles = {
  container: {
    display: 'grid',
    gap: 0
  },

  item: {
    gridColumn: 1,
    gridRow: 1,
    visibility: 'visible',
    opacity: 1,
    transition: 'all .8s ease-in-out',

    hide: {
      visibility: 'hidden',
      opacity: 0,
      pointerEvents: 'none'
    }
  },

  pagination: {
    display: 'flex',
    justifyContent: 'center'
  },

  page: {
    width: 6,
    height: 6,
    background: _colorsConfig2.default.background1,
    marginRight: 5,
    cursor: 'pointer',

    active: {
      transition: 'background .4s ease-in-out',
      background: _colorsConfig2.default.primary1
    }
  }
};

var SimpleCarousel = exports.SimpleCarousel = (0, _radium2.default)(SimpleCarouselBase);