'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Marger = exports.MargerBase = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _screenConfig = require('kitten/constants/screen-config');

var _typographyConfig = require('kitten/constants/typography-config');

var _typographyConfig2 = _interopRequireDefault(_typographyConfig);

var _isStringANumber = require('is-string-a-number');

var _isStringANumber2 = _interopRequireDefault(_isStringANumber);

var _string = require('kitten/helpers/utils/string');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MargerBase = exports.MargerBase = function (_Component) {
  _inherits(MargerBase, _Component);

  function MargerBase(props) {
    _classCallCheck(this, MargerBase);

    // Use 10px as gutter base and transform it to have a rem unit.
    var _this = _possibleConstructorReturn(this, (MargerBase.__proto__ || Object.getPrototypeOf(MargerBase)).call(this, props));

    _this.marginSize = function (value) {
      return value * _this.gutter + 'rem';
    };

    _this.valueIsNumber = function (value) {
      // Retro-compatibility: this handles the case when the user enters `.5` as a
      // value for a margin.
      if (typeof value === 'string' && value.match(/^-?\.\d+$/)) {
        return true;
      }

      return (0, _isStringANumber2.default)(String(value));
    };

    _this.propIsNumber = function (propName) {
      return _this.valueIsNumber(_this.props[propName]);
    };

    _this.isPropWithViewportRange = function (propName, viewportRange) {
      return _this.props[propName] && _this.props[propName]['from' + (0, _string.upcaseFirst)(viewportRange)];
    };

    _this.viewportRangeCssRule = function (viewportRange) {
      return '@media (min-width: ' + _screenConfig.ScreenConfig[viewportRange.toUpperCase()].min + 'px)';
    };

    _this.propCssDeclarationForViewportRange = function (propName, viewportRange) {
      var size = _this.props[propName]['from' + (0, _string.upcaseFirst)(viewportRange)];
      var cssRule = 'margin' + (0, _string.upcaseFirst)(propName);

      return _defineProperty({}, cssRule, _this.marginSize(size));
    };

    _this.viewportRangeStyleCondition = function (propName, viewportRange) {
      var hasValue = _this.isPropWithViewportRange(propName, viewportRange);

      if (!hasValue) return null;

      var viewportRangeCssRule = _this.viewportRangeCssRule(viewportRange);
      var viewportRangeCssValue = _this.propCssDeclarationForViewportRange(propName, viewportRange);

      return _defineProperty({}, viewportRangeCssRule, viewportRangeCssValue);
    };

    _this.hasDefaultProp = function (propName) {
      return _this.props[propName] && _this.props[propName].default;
    };

    _this.hasXxsProp = function (propName) {
      return _this.props[propName] && _this.props[propName].fromXxs;
    };

    _this.defaultProp = function (propName) {
      var mediaQueryRule = '@media (min-width: 0)';
      var cssRule = 'margin' + (0, _string.upcaseFirst)(propName);

      if (_this.hasDefaultProp(propName)) {
        return _defineProperty({}, mediaQueryRule, _defineProperty({}, cssRule, _this.marginSize(_this.props[propName].default)));
      }

      if (_this.hasXxsProp(propName)) {
        return _defineProperty({}, mediaQueryRule, _defineProperty({}, cssRule, _this.marginSize(_this.props[propName].fromXxs)));
      }
    };

    _this.gutter = 10 / _typographyConfig2.default.root;
    return _this;
  }

  _createClass(MargerBase, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          top = _props.top,
          bottom = _props.bottom,
          style = _props.style,
          others = _objectWithoutProperties(_props, ['top', 'bottom', 'style']);

      var viewportRanges = Object.keys(_screenConfig.ScreenConfig).map(function (size) {
        return size.toLowerCase();
      }).filter(function (size) {
        return size !== 'xxs';
      });
      var viewportRangesStyles = viewportRanges.reduce(function (acc, viewportRange) {
        return [].concat(_toConsumableArray(acc), [_this2.viewportRangeStyleCondition('top', viewportRange), _this2.viewportRangeStyleCondition('bottom', viewportRange)]);
      }, []);

      var styles = [style, this.propIsNumber('top') && { marginTop: this.marginSize(top) }, this.propIsNumber('bottom') && { marginBottom: this.marginSize(bottom) }, this.defaultProp('top'), this.defaultProp('bottom')].concat(_toConsumableArray(viewportRangesStyles));

      return _react2.default.createElement(
        _radium.StyleRoot,
        null,
        _react2.default.createElement('div', _extends({ style: styles }, others))
      );
    }
  }]);

  return MargerBase;
}(_react.Component);

MargerBase.propTypes = {
  top: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.shape({
    default: _propTypes2.default.number,
    fromXxs: _propTypes2.default.number,
    frommXs: _propTypes2.default.number,
    fromS: _propTypes2.default.number,
    fromM: _propTypes2.default.number,
    fromL: _propTypes2.default.number,
    fromXl: _propTypes2.default.number
  })]),
  bottom: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.shape({
    default: _propTypes2.default.number,
    fromXxs: _propTypes2.default.number,
    frommXs: _propTypes2.default.number,
    fromS: _propTypes2.default.number,
    fromM: _propTypes2.default.number,
    fromL: _propTypes2.default.number,
    fromXl: _propTypes2.default.number
  })])
};
MargerBase.defaultProps = {
  top: null,
  bottom: null
};

var Marger = exports.Marger = function (_Component2) {
  _inherits(Marger, _Component2);

  function Marger() {
    _classCallCheck(this, Marger);

    return _possibleConstructorReturn(this, (Marger.__proto__ || Object.getPrototypeOf(Marger)).apply(this, arguments));
  }

  _createClass(Marger, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _radium.StyleRoot,
        null,
        _react2.default.createElement(MargerBase, this.props)
      );
    }
  }]);

  return Marger;
}(_react.Component);