'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.List = exports.ListBase = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _arrowIcon = require('kitten/components/icons/arrow-icon');

var _colorsConfig = require('kitten/constants/colors-config');

var _colorsConfig2 = _interopRequireDefault(_colorsConfig);

var _typography = require('kitten/helpers/utils/typography');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ArrowIcon = (0, _radium2.default)(_arrowIcon.ArrowIcon);

var ListButtonItem = function (_Component) {
  _inherits(ListButtonItem, _Component);

  function ListButtonItem() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ListButtonItem);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ListButtonItem.__proto__ || Object.getPrototypeOf(ListButtonItem)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      focus: false
    }, _this.handleKeyPress = function (event) {
      var _this$props = _this.props,
          onKeyPress = _this$props.onKeyPress,
          onClick = _this$props.onClick;

      var enterKey = 13;
      var spaceKey = 32;

      switch (event.which) {
        case enterKey:
        case spaceKey:
          event.preventDefault;
          onClick();
          onKeyPress();
          break;
      }
    }, _this.updateFocus = function (focusState) {
      _this.setState({ focus: focusState });
    }, _this.handleFocus = function (event) {
      _this.updateFocus(true);
      _this.props.onFocus();
    }, _this.handleBlur = function () {
      _this.updateFocus(false);
      _this.props.onBlur();
    }, _this.handleMouseEnter = function () {
      _this.updateFocus(true);
      _this.props.onMouseEnter();
    }, _this.handleMouseLeave = function () {
      _this.updateFocus(false);
      _this.props.onMouseLeave();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ListButtonItem, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          disabled = _props.disabled,
          style = _props.style,
          onClick = _props.onClick,
          withTopBorder = _props.withTopBorder,
          others = _objectWithoutProperties(_props, ['children', 'disabled', 'style', 'onClick', 'withTopBorder']);

      var focus = this.state.focus;


      var buttonStyles = [styles.buttonItem.base, style, withTopBorder && styles.buttonItem.topBorder, disabled && styles.buttonItem.disabled];

      var arrowStyles = [styles.buttonItem.icon.base, disabled && styles.buttonItem.icon.disabled, !disabled && focus && styles.buttonItem.icon.focus];

      return _react2.default.createElement(
        _radium.StyleRoot,
        null,
        _react2.default.createElement(
          'div',
          _extends({}, others, {
            role: 'button',
            style: buttonStyles,
            tabIndex: '0',
            onClick: disabled ? null : onClick,
            onKeyPress: disabled ? null : this.handleKeyPress,
            onMouseEnter: this.handleMouseEnter,
            onFocus: this.handleFocus,
            onMouseLeave: this.handleMouseLeave,
            onBlur: this.handleBlur
          }),
          _react2.default.createElement(
            'div',
            { style: styles.buttonItem.content },
            children
          ),
          _react2.default.createElement(
            'div',
            { style: styles.buttonItem.arrow },
            _react2.default.createElement(ArrowIcon, { className: 'k-Button__icon', style: arrowStyles })
          )
        )
      );
    }
  }]);

  return ListButtonItem;
}(_react.Component);

ListButtonItem.propTypes = {
  children: _propTypes2.default.node.isRequired,
  style: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.array]),
  disabled: _propTypes2.default.bool,
  withTopBorder: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  onFocus: _propTypes2.default.func,
  onBlur: _propTypes2.default.func,
  onMouseEnter: _propTypes2.default.func,
  onMouseLeave: _propTypes2.default.func
};
ListButtonItem.defaultProps = {
  style: {},
  disabled: false,
  withTopBorder: false,
  onClick: function onClick() {},
  onFocus: function onFocus() {},
  onBlur: function onBlur() {},
  onMouseEnter: function onMouseEnter() {},
  onMouseLeave: function onMouseLeave() {}
};

var ListBase = exports.ListBase = function (_Component2) {
  _inherits(ListBase, _Component2);

  function ListBase() {
    _classCallCheck(this, ListBase);

    return _possibleConstructorReturn(this, (ListBase.__proto__ || Object.getPrototypeOf(ListBase)).apply(this, arguments));
  }

  _createClass(ListBase, [{
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          children = _props2.children,
          style = _props2.style;


      var listStyles = [styles.list, style];

      return _react2.default.createElement(
        'ul',
        { style: listStyles },
        _react2.default.Children.map(children, function (child, index) {
          if (!_react2.default.isValidElement(child)) return null;

          return _react2.default.createElement(
            'li',
            null,
            child
          );
        })
      );
    }
  }]);

  return ListBase;
}(_react.Component);

ListBase.ButtonItem = ListButtonItem;


ListBase.propTypes = {
  children: _propTypes2.default.node.isRequired
};

var styles = {
  list: {
    listStyle: 'none',
    margin: 0,
    padding: 0
  },
  buttonItem: {
    base: {
      display: 'flex',
      borderLeft: _colorsConfig2.default.line1 + ' 0.125rem solid',
      borderRight: _colorsConfig2.default.line1 + ' 0.125rem solid',
      borderBottom: _colorsConfig2.default.line1 + ' 0.125rem solid',
      cursor: 'pointer',
      paddingLeft: '1.25rem',
      paddingRight: '1.25rem',
      ':hover': {
        backgroundColor: _colorsConfig2.default.background2
      }
    },
    topBorder: {
      borderTop: _colorsConfig2.default.line1 + ' 0.125rem solid'
    },
    disabled: {
      color: _colorsConfig2.default.line2,
      backgroundColor: _colorsConfig2.default.background1,
      cursor: 'not-allowed',
      ':hover': {
        backgroundColor: _colorsConfig2.default.background1
      }
    },
    content: {
      flexGrow: 1
    },
    arrow: {
      display: 'flex',
      alignItems: 'center'
    },
    icon: {
      base: {
        position: 'relative',
        left: 0,
        transition: 'left .2s'
      },
      focus: {
        left: (0, _typography.pxToRem)(5)
      },
      disabled: {
        fill: _colorsConfig2.default.line2
      }
    }
  }
};

var List = exports.List = (0, _radium2.default)(ListBase);