'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Timeline = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _screenConfig = require('kitten/constants/screen-config');

var _mediaQueries = require('kitten/hoc/media-queries');

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _text = require('kitten/components/typography/text');

var _marger = require('kitten/components/layout/marger');

var _colorsConfig = require('kitten/constants/colors-config');

var _colorsConfig2 = _interopRequireDefault(_colorsConfig);

var _pathOr = require('ramda/src/pathOr');

var _pathOr2 = _interopRequireDefault(_pathOr);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _typographyConfig = require('kitten/constants/typography-config');

var _typographyConfig2 = _interopRequireDefault(_typographyConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Marger = (0, _radium2.default)(_marger.Marger);
var Text = (0, _radium2.default)(_text.Text);

var Timeline = exports.Timeline = function (_Component) {
  _inherits(Timeline, _Component);

  function Timeline() {
    _classCallCheck(this, Timeline);

    return _possibleConstructorReturn(this, (Timeline.__proto__ || Object.getPrototypeOf(Timeline)).apply(this, arguments));
  }

  _createClass(Timeline, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          itemHeight = _props.itemHeight;

      var arrayOfChildren = _react2.default.Children.toArray(children);
      var bulletStyle = [styles.circle, styles.circleMarger[itemHeight]];

      return _react2.default.createElement(
        _radium.StyleRoot,
        { style: styles.timelineContainer },
        _react2.default.createElement('span', { style: styles.verticalDashedLine }),
        _react2.default.createElement(
          'ol',
          { style: styles.customList },
          _react2.default.Children.map(arrayOfChildren, function (child, index) {
            return _react2.default.createElement(
              'li',
              { style: styles.list },
              _react2.default.createElement(
                Text,
                { size: 'tiny', style: bulletStyle },
                ++index
              ),
              _react2.default.createElement(
                Marger,
                { top: '2.5', bottom: '2.5', style: styles.textList },
                child
              )
            );
          })
        )
      );
    }
  }]);

  return Timeline;
}(_react.Component);

Timeline.propTypes = {
  children: _propTypes2.default.node.isRequired,
  itemHeight: _propTypes2.default.oneOf(['thin', 'large'])
};

Timeline.defaultProps = {
  itemHeight: 'large'
};

var circleSize = 50;

var styles = {
  timelineContainer: _defineProperty({
    position: 'relative'

  }, '@media (max-width: ' + _screenConfig.ScreenConfig.XS.max + 'px)', {
    marginLeft: 20
  }),
  verticalDashedLine: {
    backgroundImage: 'linear-gradient(' + _colorsConfig2.default.line1 + ' 50%,\n      rgba(255, 255, 255, 0) 0%)',
    backgroundPosition: 'right',
    backgroundSize: '2px 8px',
    backgroundRepeat: 'repeat-y',
    position: 'absolute',
    height: '100%',
    top: 0,
    left: -1,
    width: 2
  },
  customList: {
    listStyleType: 'none',
    padding: 0,
    margin: 0
  },
  circle: _extends({
    boxSizing: 'border-box',
    height: circleSize,
    width: circleSize,
    border: '2px solid ' + _colorsConfig2.default.line1,
    backgroundColor: _colorsConfig2.default.background1,
    borderRadius: '50%',
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center',
    marginRight: 40,
    marginLeft: -circleSize / 2,
    lineHeight: 0,
    flex: '0 0 ' + circleSize + 'px',
    position: 'relative'
  }, _typographyConfig2.default.fontStyles.bold, _defineProperty({}, '@media (max-width: ' + _screenConfig.ScreenConfig.XS.max + 'px)', {
    marginRight: 20
  })),
  circleMarger: {
    large: _defineProperty({
      marginTop: 80,
      marginBottom: 80

    }, '@media (min-width: ' + _screenConfig.ScreenConfig.S.min + 'px) and\n        (max-width: ' + _screenConfig.ScreenConfig.M.max + 'px)', {
      marginTop: 60,
      marginBottom: 60
    }),
    thin: _defineProperty({
      marginTop: 40,
      marginBottom: 40

    }, '@media (min-width: ' + _screenConfig.ScreenConfig.S.min + 'px) and\n        (max-width: ' + _screenConfig.ScreenConfig.M.max + 'px)', {
      marginTop: 20,
      marginBottom: 20
    })
  },
  list: {
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'space-between'
  },
  textList: {
    flexGrow: 1,
    alignItems: 'center'
  }
};